OpenShot Audio Library | OpenShotAudio: juce::ThreadLocalValue< Type > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::ThreadLocalValue< Type > Class Template Reference

`#include <juce_ThreadLocalValue.h>`

## Public Member Functions
| ~ThreadLocalValue ()
Type & | operator* () const noexcept
| operator Type * () const noexcept
Type * | operator-> () const noexcept
ThreadLocalValue & | operator= (const Type &newValue)
Type & | get () const noexcept
void | releaseCurrentThreadStorage ()

## Detailed Description

template<typename Type>
class juce::ThreadLocalValue< Type >

Provides cross-platform support for thread-local objects.

This class holds an internal list of objects of the templated type, keeping an instance for each thread that requests one. The first time a thread attempts to access its value, an object is created and added to the list for that thread.

Typically, you'll probably want to create a static instance of a ThreadLocalValue object, or hold one within a singleton.

The templated class for your value must be a primitive type, or a simple POD struct.

When a thread no longer needs to use its value, it can call releaseCurrentThreadStorage() to allow the storage to be re-used by another thread. If a thread exits without calling this method, the object storage will be left allocated until the ThreadLocalValue object is deleted.

Definition at line 47 of file juce_ThreadLocalValue.h.

## Constructor & Destructor Documentation

## ◆ ~ThreadLocalValue()

template<typename Type >

juce::ThreadLocalValue< Type >::~ThreadLocalValue | ( |  | ) |
| inline

Destructor. When this object is deleted, all the value objects for all threads will be deleted.

Definition at line 56 of file juce_ThreadLocalValue.h.

## Member Function Documentation

## ◆ get()

template<typename Type >

Type & juce::ThreadLocalValue< Type >::get | ( |  | ) | const
| inlinenoexcept

Returns a reference to this thread's instance of the value. Note that the first time a thread tries to access the value, an instance of the value object will be created - so if your value's class has a non-trivial constructor, be aware that this method could invoke it.

Definition at line 95 of file juce_ThreadLocalValue.h.

Referenced by juce::ThreadLocalValue< juce::Thread * >::operator juce::Thread * *(), juce::ThreadLocalValue< Type >::operator*(), juce::ThreadLocalValue< Type >::operator->(), and juce::ThreadLocalValue< Type >::operator=().

## ◆ operator Type *()

template<typename Type >

juce::ThreadLocalValue< Type >::operator Type * | ( |  | ) | const
| inlinenoexcept

Returns a pointer to this thread's instance of the value. Note that the first time a thread tries to access the value, an instance of the value object will be created - so if your value's class has a non-trivial constructor, be aware that this method could invoke it.

Definition at line 78 of file juce_ThreadLocalValue.h.

## ◆ operator*()

template<typename Type >

Type & juce::ThreadLocalValue< Type >::operator* | ( |  | ) | const
| inlinenoexcept

Returns a reference to this thread's instance of the value. Note that the first time a thread tries to access the value, an instance of the value object will be created - so if your value's class has a non-trivial constructor, be aware that this method could invoke it.

Definition at line 71 of file juce_ThreadLocalValue.h.

## ◆ operator->()

template<typename Type >

Type * juce::ThreadLocalValue< Type >::operator-> | ( |  | ) | const
| inlinenoexcept

Accesses a method or field of the value object. Note that the first time a thread tries to access the value, an instance of the value object will be created - so if your value's class has a non-trivial constructor, be aware that this method could invoke it.

Definition at line 85 of file juce_ThreadLocalValue.h.

## ◆ operator=()

template<typename Type >

ThreadLocalValue & juce::ThreadLocalValue< Type >::operator= | ( | const Type & | newValue | ) |
| inline

Assigns a new value to the thread-local object.

Definition at line 88 of file juce_ThreadLocalValue.h.

## ◆ releaseCurrentThreadStorage()

template<typename Type >

void juce::ThreadLocalValue< Type >::releaseCurrentThreadStorage | ( |  | ) |
| inline

Called by a thread before it terminates, to allow this class to release any storage associated with the thread.

Definition at line 121 of file juce_ThreadLocalValue.h.

The documentation for this class was generated from the following file:

- juce_ThreadLocalValue.h